<template>
  <div>
    <ObInput
      v-model="searchQuery"
      placeholder="Например, название компании, ИНН, город"
      icon="search"
      class="search"
    />

    <ObTable
      :columns="columns"
      :functional-panel="true"
      :show-add-button="false"
      ref="participantsTable"
      class="participants-table"
      :table-height="452"
      :with-checkboxes="true"
      :checked-rows="selectedUuids"
      :search-query="searchQuery"
      :is-functional-group="false"
      :is-functional-sort="false"
      :is-functional-search="false"
      :remote-opt="{
        method: fetchTableData,
        contentKey: 'participants'
      }"
      @row-toggle="onToggle"
      data-qa="tendersGroupsAddToGroupForm"
    >
      <template slot="noneContent">
        <div class="title">Список контрагентов пуст</div>
      </template>

      <template
        slot="groups"
        slot-scope="{ data }"
      >
        <span
          v-for="group in data.item.groups"
          :key="group.uuid"
          class="in-group-name"
        >
          {{ group.name }}
        </span>
      </template>
    </ObTable>
  </div>
</template>

<script>
  import api from '@/api'
  import ObInput from 'common-components/src/obComponents/obInput'
  import ObTable from 'common-components/src/obComponents/obTable'

  export default {
    name: 'TendersAddToGroup',
    components: {
      ObInput,
      ObTable
    },
    data () {
      return {
        api,
        searchQuery: null,
        selectedUuids: []
      }
    },
    computed: {
      columns () {
        return [
          {
            title: 'Название контрагента',
            key: 'shortTitle',
            fixed: true
          },
          {
            title: 'ИНН',
            key: 'inn'
          },
          {
            title: 'Юридический адрес',
            key: 'legalAddress'
          },
          {
            title: 'Описание',
            key: 'description',
            html: ({ description }) => this.getDescription(description)
          },
          {
            title: 'Телефон',
            key: 'email'
          },
          {
            title: 'Эл. почта',
            key: 'phone'
          },
          {
            title: 'Входит в группы',
            slotName: 'groups',
            key: 'groups'
          }
        ]
      }
    },
    methods: {
      async fetchTableData (params) {
        const { data } = await api.tendersContractors.getParticipantGroupOutside(this.$route.params.uuid, params)

        return data
      },
      async reloadData () {
        this.selectedUuids = []

        this.$refs.participantsTable.loadData({ init: true })
      },
      getDescription (description) {
        return description || '—'
      },
      onToggle (item, selectedUuids) {
        this.selectedUuids = selectedUuids

        this.$emit('change', this.selectedUuids)
      }
    }
  }
</script>

<style lang="scss" scoped>
  .search {
    margin-bottom: 20px;

    &::v-deep .icon {
      color: $gray-slate;
    }
  }

  .participants-table {
    border: 1px solid $lavender;
    white-space: nowrap;

    .in-group-name:not(:last-child) {
      display: flex;

      &:after {
        content: ', ';
      }
    }
  }
</style>
